## ldaptor 0.0.26

=== doc/Makefile ===
DIAS:= \
	chat-bind.dia \
	chat-search.dia \
	chat-search-pipeline.dia \
	chat-unbind.dia \
	ldapfilter-as-tree.dia \
	ldap-is-a-tree.dia

DIAPNG:=$(DIAS:%.dia=%.dia.png)

DOCBOOK:=ldap-intro.xml
SLIDES:=addressbook-slides.xml

GENERATED:=\
	$(DOCBOOK:%.xml=%.html) \
	$(SLIDES:%.xml=%/index.html) \
	$(DIAPNG)

XMLIFY:=sed 's/&/\&amp;/g; s/</\&lt;/g; s/>/\&gt;/g'

all:: $(GENERATED)

install: api $(GENERATED)
	@[ -n '$(DESTDIR)' ] || { echo 'Please provide variable DESTDIR pointing to desired location of documents.' 1>&2; exit 1; }
	install -d -m0755 '$(DESTDIR)'
	cp -ar api addressbook-slides '$(DESTDIR)/'
	install -d -m0755 '$(DESTDIR)/ldap-intro'
	install -m0644 ldap-intro.html '$(DESTDIR)/ldap-intro/index.html'
	install -m0644 $(DIAPNG) '$(DESTDIR)/ldap-intro'
	find examples -name SCCS -prune -o -type f -exec \
		install -D -m0644 '{}' '$(DESTDIR)/{}' \;

install-%:
	@[ -n '$(DESTDIR)' ] || { echo 'Please provide variable DESTDIR pointing to desired location of documents.' 1>&2; exit 1; }
	install -d -m0755 '$(DESTDIR)'
	set -e; if [ -d 'examples.$*' ]; then \
		find 'examples.$*' -name SCCS -prune -o -type f -printf '%P\0' \
		| xargs -0 --replace -- \
			install -D -m0644 'examples.$*/{}' '$(DESTDIR)/examples/{}' ;\
	fi

clean:
	rm -f $(GENERATED)

rsync: $(GENERATED)
	rsync -a $(DOCBOOK:%.xml=%.html) $(SLIDES:%.xml=%) $(DIAPNG) pyramid.twistedmatrix.com:public_html/ldap-intro/
	rsync -a --exclude '*.pyc' --exclude SCCS --exclude '*~' examples/addressbook/{[0-9]*,README.txt,server}  pyramid.twistedmatrix.com:public_html/ldap-intro/addressbook/

$(DOCBOOK:%.xml=%.html): %.html: %.xml
	xsltproc  --nonet \
		/usr/share/sgml/docbook/stylesheet/xsl/nwalsh/xhtml/docbook.xsl \
		$< \
		>$@.tmp
	mv $@.tmp $@

addressbook-ldif/%.xml: examples/addressbook/server/%.ldif
	install -d -m0755 '$(@D)'
	$(XMLIFY) <$< >$@.tmp
	mv $@.tmp $@

addressbook-session/session-%.xml: examples/addressbook/01_repl/session-%
	install -d -m0755 '$(@D)'
	$(XMLIFY) <$< >$@.tmp
	mv $@.tmp $@

addressbook-slides/addressbookpy-02_script.html: \
	examples/addressbook/02_script/addressbook.py tags.j2h
	install -d -m0755 '$(@D)'
	( echo '<font size="+1">' && source-highlight --out-format=xhtml --src-lang=python && echo '</font>' ) <$< >$@.tmp
	mv $@.tmp $@

addressbook-slides/index.html: \
	ldapentry-vs-oo.xml search-inputs.xml

ldap-intro.html: \
	ldapentry-vs-oo.xml search-inputs.xml

$(SLIDES:%.xml=%/index.html): %/index.html: %.xml \
	slides-driver.xsl \
	Makefile $(DIAPNG) \
	addressbook-ldif/doe.xml \
	addressbook-ldif/smith.xml \
	addressbook-session/session-01.xml \
	addressbook-session/session-02.xml \
	addressbook-session/session-03.xml \
	addressbook-session/session-04.xml \
	addressbook-session/session-05.xml \
	addressbook-session/session-06.xml \
	addressbook-session/session-07.xml \
	addressbook-session/session-08.xml \
	addressbook-session/session-09.xml \
	slide-style.css \
	addressbook-slides/addressbookpy-02_script.html
	install -d -m0755 '$(@D)'
	cp -ar /usr/share/sgml/docbook/custom/slides/3.2.0/graphics '$(@D)'
	cp -ar /usr/share/sgml/docbook/custom/slides/3.2.0/browser '$(@D)'
	patch '$(@D)/browser/overlay.js' <overlay.js.patch
	cp $(DIAPNG) '$(@D)'
	cp slide-style.css '$(@D)'
	# TODO --nonet
	cd '$(@D)' && xsltproc \
		--stringparam keyboard.nav 1 \
		--stringparam overlay 1 \
		--stringparam output.indent yes \
		--stringparam graphics.dir graphics \
		--stringparam script.dir browser \
		../slides-driver.xsl \
		'$(addprefix ../,$<)'
	perl -pi -e '\
		s{<a href="(.*?)" target="_top">Click me!</a>}{<iframe width=900 height=600 src="$$1" />}g; \
		s{(Please examine the differences between (.*?) and (.*?)\.)}{<object type="text/plain" data="/diff/$$2/$$3">$$1</object>}g; \
		s{class="speaker-instructions"}{class="speaker-instructions-done"}; \
		' \
		'$(@D)'/foil*.html

%.dia.png: %.dia
	dia --export-to-format=png --export=$@.tmp $<
	mv $@.tmp $@

api:
	epydoc \
	        -o api \
		-n Ldaptor \
	        -u http://tv.debian.net/software/ldaptor/ \
		$$(find ../ldaptor \( -name SCCS -prune \) -o -name '*.py' -print)

.PHONY: api

=== debian/changelog ===
ldaptor (0.0.26) unstable; urgency=low

  * Documentation changes:
    - Archive sketch of the interfaces (with no explanation :).

  * Bugfixes:
    - Override __eq__ and __ne__ in pureber.BERBase too, otherwise
      UserList's implementation of those overrode BERBase.__cmp__ and
      caused false equalities.
    - Reimplement ldapfilter, with Unit Test flavor. Use pyparsing
      to make it really handle extra data and backslash escaping.
    - When calling filt.asText() for LDAP filters, make sure to
      backslash escape special characters.

  * Cleanups:
    - Typo in docstring.
    - Add nicer repr of pureldap.LDAPMatchingRuleAssertion, to make the
      problem easier to spot.

  * Packaging:
    - Depend on pythonX.Y-pyparsing.
    - New enough dia is in unstable, so upload to unstable again.

  * Administrivia:
    - Add TODO notes.

 -- Tommi Virtanen <tv@debian.org>  Sat, 26 Jun 2004 14:34:06 +0300

ldaptor (0.0.25) experimental; urgency=low

  * Pre-generate documentation in build target, don't wait until
    install target. Makes dia work with dpkg-buildpackage
    -rfakeroot, because "debian/rules build" is run without
    fakeroot, and then dia can scribble in the home directory of
    the real user, not /root/.dia. Ungh. I'm filing a bug on dia.

 -- Tommi Virtanen <tv@debian.org>  Mon, 17 May 2004 19:51:11 +0300

ldaptor (0.0.24) experimental; urgency=low

  * Applications changes:
    - Can now generate diffs of two LDAP entries, or even two full trees,
      and use that either to modify LDAP entries at a server, or generate
      LDIF modification commands. Can also parse LDIF modification files.
      See ldaptor-ldifdiff, ldaptor-ldifpatch.

  * Documentation changes:
    - Addressbook example source:
      - Bugfixes and cleanups.
      - Rewrite addressbook examples to use nevow instead of woven
        and make them runnable via .tac files.
    - Modernize addressbook-slides:
      - Remove htmldiff hack, use meld instead. Simplify things a bit.
      - Add new addressbook-slides-server.tac that launches meld
        automatically when you load that page, useful for presentations.
      - Add CSS stylesheet.
      - New DTD version, fix to conform to DTD.
      - Split 01_repl into screen-size chunks.
    - In addressbook slides, use smaller pictures to make sure they fit on
      screen.
    - In addressbook examples, let one user have a valid password and edit
      access, so the same server can be used to demo ldaptor-webui.
    - Note in ldap-intro documentation that OpenLDAP doesn't allow
      changing objectClasses of existing objects.
    - Fix typo in doc/examples/ldif2ldif.
    - Docstring cleanup.
    - Switch from graphviz to dia for figures. (Closes: #242147)
    - In example LDIFs, rename Erkki Esim to Ample Exam, for i18n.

  * API changes:
    - First stages of LDIFTree work; initial support for storing LDIFs in a
      tree form.
    - Add inmemory data backend.
    - Start using interfaces, abstract common LDAP entry things into
      ldaptor.entry, ldaptor.attributeset.
    - Add module ldaptor.delta.
    - Add LDAPEntry.match().
    - Add IConnectedLDAPEntry.lookup().
    - The LDAP server prototype code has changed a lot, not summarizing
      here.
    - Rename ldifprotocol.LDIF.completed() to more specific
      gotEntry(), so inmemory DB loading can have .gotDatabase() or
      something, and .completed() won't look confusing there.
    - Switch ldifprotocol into producing BaseLDAPEntries.
    - Add ldaptor.entry.EditableLDAPEntry, make
      ldapsyntax.LDAPEntryWithClient inherit EditableLDAPEntry.
    - Make LDAPConnector accepts dns also as strings.
    - LDAPConnector accepts overrides that are callable, and lets them
      take control of the connecting. This is mostly meant for unit
      testing.

  * Internal refactorings:
    - Refactor to remove client-specific details from LDAPAttributeSet and
      to generalize the concept of a Modification so it can be used with
      LDIF also.
    - Refactor LDAPAttributeSet to interits Set.
    - Switch BaseLDAPEntry to a be a new-style class.

  * Bugfixes:
    - Fix webui search basedn navilinks.
    - In ldaptor-fetchschema, start logging so errors are reported to the
      user.
    - Ignore case in attributeType names.
    - LDIF parsing:
      - Support splitted lines in ldifprotocol.LDIF.
      - Fix LDIF parsing when values have no leading space.
      - Protect against "<" values (external URL) in LDIF parsing.
      - Make ldifprotocol support versioned LDIF files.
    - Make LDAPServer error handling to actually talk sane
      things on the wire.
    - Detect truncated LDIF files, raise
      ldifprotocol.LDIFTruncatedError.
    - Handle different capitalizations of 'objectClass' in
      BaseLDAPEntry.
    - Finish schema parsing.
    - Fix bug where ldapserver raises an exception on non-anonymous
      binds. It was missed in ldaperrors refactor, add unit tests so it
      will not be missed again. (Closes: #244543)
    - When LDAPServer receives unknown protocol requests, reply sanely and
      do not close the connection. Thanks to Guido Trotter.
      (Closes: #244861)
    - Notice differences in attributeType when comparing
      LDAPAttributeSets.
    - In LDAPAttributeSet, override those parts of sets.Set which
      assume class creation works without arguments (as we need the
      key always).

  * Cleanups:
    - Start gathering unit tests for the server protocol.
    - Stringify MutableStrings to simplify things. MutableStrings
      shouldn't leak out of pureber and pureldap.
    - Use the canonical way to write objectClass in
      pureldap.LDAPFilterMatchAll; especially needed as the server code is
      currently case-dependent.
    - Nicer repr for LDAPAttributeSets.
    - Make sure BaseLDAPEntry LDIFfication lists attribute values in
      sorted order for reproducability.
    - Add comparisons to RelativeDistingushedName in order to have


=== debian/control ===
Source: ldaptor
Section: admin
Priority: optional
Maintainer: Tommi Virtanen <tv@debian.org>
Standards-Version: 3.5.6
Build-Depends-Indep: python2.2-dev, python2.3-dev, debhelper (>= 4.1.68), docbook-slides (>= 3.2.0), xsltproc, source-highlight, python2.3-epydoc, dia (>= 0.93-2)

Package: ldaptor-utils
Section: admin
Architecture: all
Depends: python (>= 2.3), python (<< 2.4), python2.3-ldaptor
Description: Command-line LDAP utilities
 A set of LDAP utilities for use from the command line, including:
 .
 ldaptor-search -- Search LDAP directories.
 .
 ldaptor-namingcontexts -- Fetch the naming contexts the server supports.
 .
 ldaptor-find-server -- Find the server that serves the wanted DN by
 looking at DNS SRV records.
 .
 ldaptor-passwd -- Change passwords.
 .
 ldaptor-rename -- Change object RDN and DNs.
 .
 ldaptor-ldap2passwd -- Generate passwd(5) format data from LDAP
 accounts.
 .
 ldaptor-getfreenumber -- Do an efficient scan for e.g. next free
 uidNumber.
 .
 ldaptor-ldap2dhcpconf -- Create dhcp.conf based on LDAP host info.
 .
 ldaptor-ldap2maradns -- Create a maradns zone file based on LDAP host
 info.
 .
 ldaptor-ldap2pdns -- pdns pipe backend.
 .
 ldaptor-fetchschema -- Fetch schema from a server.
 .
 ldaptor-ldifdiff -- Read two LDIF files and output LDIF modifications
 that modify entries in first file to look like entries in second file.
 .
 ldaptor-ldifpatch -- Read an LDIF file and LDIF modifications and output
 LDIF with the modifications.

Package: ldaptor-webui
Section: admin
Architecture: all
Depends: python (>= 2.3), python (<< 2.4), python2.3-ldaptor
Description: Web user interface for editing LDAP directories
 A web-based user interface to search and edit information in an LDAP
 directory.

Package: python-ldaptor
Section: python
Architecture: all
Depends: python-twisted (>= 1.1.1), python-pyparsing, pwgen, python (>= 2.3), python (<< 2.4), python2.3-ldaptor
Description: Pure-Python library for LDAP
 Ldaptor is a pure-Python library that implements
 .
 - LDAP client logic.
 .
 - separately-accessible LDAP and BER protocol message
 generation/parsing.
 .
 - ASCII-format LDAP filter generation and parsing.
 .
 - LDIF format data generation.
 .
 - Samba password changing logic.
 .
 This is a dummy package that depends on the correct version of
 python-ldaptor for the default version of Python.

Package: python2.2-ldaptor
Section: python
Architecture: all
Depends: python2.2-twisted (>= 1.1.1), python2.2-pyparsing, pwgen, python2.2
Description: Pure-Python library for LDAP
 Ldaptor is a pure-Python library that implements
 .
 - LDAP client logic.
 .
 - separately-accessible LDAP and BER protocol message
 generation/parsing.
 .
 - ASCII-format LDAP filter generation and parsing.
 .
 - LDIF format data generation.
 .
 - Samba password changing logic.
 .
 This version is usable with python2.2

Package: python2.3-ldaptor
Section: python
Architecture: all
Depends: python2.3-twisted (>= 1.1.1), python2.3-pyparsing, pwgen, python2.3
Description: Pure-Python library for LDAP
 Ldaptor is a pure-Python library that implements
 .
 - LDAP client logic.
 .
 - separately-accessible LDAP and BER protocol message
 generation/parsing.
 .
 - ASCII-format LDAP filter generation and parsing.
 .
 - LDIF format data generation.
 .
 - Samba password changing logic.
 .
 This version is usable with python2.3

Package: ldaptor-doc
Section: doc
Architecture: all
Description: Documentation for Ldaptor
 A collection of documentation about Ldaptor and LDAP, including
 .
 - An introduction to LDAP
 .
 - The Ldaptor library API
 .
 - Slides for a talk "Creating a simple LDAP application"

=== debian/rules ===
#!/usr/bin/make -f

PYTHON_VERSIONS:=2.2 2.3
PYTHON_VERSION_DEFAULT:=2.3

docdir=debian/install/$(1)/usr/share/doc/$(1)

build:
	make -C doc

install: $(foreach p,$(PYTHON_VERSIONS),install-python-$(p))
binary: binary-indep binary-arch
binary-indep: binary-indep-dummy \
	$(foreach p,$(PYTHON_VERSIONS),binary-indep-python-$(p)) \
	binary-indep-ldaptor-webui \
	binary-indep-ldaptor-utils \
	binary-indep-ldaptor-doc
binary-arch:

clean:
	test -e debian/control
	test root = "`whoami`" || (echo need root priviledges; exit 1)
	rm -rf build debian/install
	dh_clean
	find . -type f -name '*.pyc' -print0 \
	| xargs -0 --no-run-if-empty rm --
	rm -rf debian/substvars debian/files



DUMMY_INSTDIR:=debian/install/python-ldaptor
binary-indep-dummy:
	test -e debian/control
	test root = "`whoami`" || (echo need root priviledges; exit 1)

	install -d --mode=0755 \
		'$(DUMMY_INSTDIR)/DEBIAN' \
		'$(call docdir,python-ldaptor)'
	install --mode=0644 \
		debian/copyright \
		'$(call docdir,python-ldaptor)'
	install --mode=0644 \
		debian/changelog \
		'$(call docdir,python-ldaptor)/changelog'
	install --mode=0644 \
		debian/README.Debian.dummy \
		'$(call docdir,python-ldaptor)/README.Debian'
	gzip -9f \
		'$(call docdir,python-ldaptor)/README.Debian' \
		'$(call docdir,python-ldaptor)/changelog'
	dh_python -p'python-ldaptor' -P'$(DUMMY_INSTDIR)'
	dpkg-gencontrol -isp -p'python-ldaptor' -P'$(DUMMY_INSTDIR)'
	dpkg --build '$(DUMMY_INSTDIR)' ..


install-python-%:
	test -e debian/control
	test root = "`whoami`" || (echo need root priviledges; exit 1)
	rm -rf debian/substvars
	install -d -m0755 'debian/install/python$*-ldaptor'
	/usr/bin/python$* setup-python-ldaptor.py install --root='debian/install/python$*-ldaptor'
	rm -rf build
	chmod -R go-w 'debian/install/python$*-ldaptor'

	install -d --mode=0755 '$(call docdir,python$*-ldaptor)'
	install --mode=0644 \
		README \
		TODO \
		debian/copyright \
		'$(call docdir,python$*-ldaptor)'
	install --mode=0644 \
		debian/changelog \
		'$(call docdir,python$*-ldaptor)/changelog'
	gzip -9f \
		'$(call docdir,python$*-ldaptor)/README' \
		'$(call docdir,python$*-ldaptor)/changelog'


install-ldaptor-%:
	test -e debian/control
	test root = "`whoami`" || (echo need root priviledges; exit 1)
	rm -rf debian/substvars
	install -d -m0755 'debian/install/ldaptor-$*'
	/usr/bin/python$(PYTHON_VERSION_DEFAULT) \
		setup-ldaptor-$*.py install --root='debian/install/ldaptor-$*'
	rm -rf build
	chmod -R go-w 'debian/install/ldaptor-$*'

	install -d --mode=0755 '$(call docdir,ldaptor-$*)'
	install --mode=0644 \
		README \
		TODO \
		debian/copyright \
		'$(call docdir,ldaptor-$*)'
	make -C doc 'install-$*' DESTDIR='$(PWD)/$(call docdir,ldaptor-$*)'
	install --mode=0644 \
		debian/changelog \
		'$(call docdir,ldaptor-$*)/changelog'
	gzip -9f \
		'$(call docdir,ldaptor-$*)/README' \
		'$(call docdir,ldaptor-$*)/changelog'

install-ldaptor-doc:
	test -e debian/control
	test root = "`whoami`" || (echo need root priviledges; exit 1)
	rm -rf debian/substvars
	install -d -m0755 'debian/install/ldaptor-doc'
	make -C doc install DESTDIR='$(PWD)/$(call docdir,ldaptor-doc)'
	install --mode=0644 \
		README \
		TODO \
		debian/copyright \
		'$(call docdir,ldaptor-doc)'
	install --mode=0644 \
		debian/changelog \
		'$(call docdir,ldaptor-doc)/changelog'
	gzip -9f \
		'$(call docdir,ldaptor-doc)/README' \
		'$(call docdir,ldaptor-doc)/changelog'

binary-indep-python-%: install-python-%
	test -e debian/control
	test root = "`whoami`" || (echo need root priviledges; exit 1)

	install -d --mode=0755 'debian/install/python$*-ldaptor/DEBIAN'
	dh_python -p'python$*-ldaptor' -P'debian/install/python$*-ldaptor'
	dpkg-gencontrol \
		-isp -p'python$*-ldaptor' -P'debian/install/python$*-ldaptor'
	dpkg --build 'debian/install/python$*-ldaptor' ..

binary-indep-ldaptor-%: \
	install-ldaptor-webui \
	install-ldaptor-utils \
	install-ldaptor-doc
	test -e debian/control
	test root = "`whoami`" || (echo need root priviledges; exit 1)

	install -d --mode=0755 'debian/install/ldaptor-$*/DEBIAN'
	dh_python -p'ldaptor-$*' -P'debian/install/ldaptor-$*'
	dpkg-gencontrol \
		-isp -p'ldaptor-$*' -P'debian/install/ldaptor-$*'
	dpkg --build 'debian/install/ldaptor-$*' ..

.PHONY: build clean binary-indep binary-arch binary \
	binary-indep-dummy \
	binary-arch-python-% install-python-%

## ldaptor 0.0.38ubuntu1

=== debian/changelog ===
ldaptor (0.0.38ubuntu1) hoary; urgency=low

  * Sync with Debian
  * Update to Python 2.4

 -- Brandon Hale <brandon@smarterits.com>  Thu, 10 Mar 2005 11:36:33 -0500

ldaptor (0.0.38) unstable; urgency=low

  * Bugfixes:
    - WebUI:
      - rewrite webui search DN linking to be more nevowy and not assume
        ldaptor is the root resource.

 -- Tommi Virtanen <tv@debian.org>  Fri,  4 Mar 2005 14:46:28 +0200

ldaptor (0.0.37) unstable; urgency=low

  * Bugfixes:
    - ldaptor.checkers:
      - trap LDAPUnwillingToPerform and make it just an UnauthorizedLogin
        in LDAPBindingChecker.
    - WebUI:
      - do not stringify i18n PlaceHolder, just pass it through to
        flattening.
      - Port nevow commits r1252 and r1253: handle interpolation of i18n
        strings better.
      - Make zebra tables not reverse colors on refresh, by moving state
        from resource to request.

  * Cleanups:
    - Remove dead code.
    - Use CSS in webui service password changing layout.

 -- Tommi Virtanen <tv@debian.org>  Wed, 23 Feb 2005 23:00:57 +0200

ldaptor (0.0.36) unstable; urgency=low

  * Applications changes:
    - Enforce validFrom and validUntil in ServiceBindingProxy. Closes:
      ldaptor#22.
    - I18n support in webui and translation to finnish.

  * API changes:
    - Do not parallelize password setting, abort on first error.
    - When aborting password setting, use a real exception and not a
      string as explanation.

  * Refactorings to adapt to Twisted/Nevow APIs:
    - In webui, use annotate.Choice in a way that works with nevow 0.3 and
      0.4pre.

  * Bugfixes:
    - Add ldaptor.protocols.ldap.autofill that was missed earlier.
    - Clean up and python2.4-proof LDAPAttributeTypeAndValue parsing.
    - Do not repeat the form error message for each argument in webui
      change_password.

  * Cleanups:
    - WebUI:
      - refactor to separate service password setting, for reuse
        elsewhere.
      - make zebra tables set CSS styles, not just background colors.
      - redo webui service password changing form layout.
      - avoid annotate.Password in webui password changing, it
        results in poor layout.
      - use table for nicer layout of service password controls.

  * Packaging:
    - Add missing depends on python2.3-pyopenssl, python2.3-crypto.

  * Administrivia:
    - Run unit tests after the install target, with the installed code
      base.

 -- Tommi Virtanen <tv@debian.org>  Wed, 23 Feb 2005 11:13:08 +0200

ldaptor (0.0.35) unstable; urgency=low

  * Bugfixes:
    - Fix LDAPServer to understand new e.bind() semantics from r196.

  * Packaging:
    - Bumped standards version to 3.6.1.

 -- Tommi Virtanen <tv@debian.org>  Fri, 28 Jan 2005 19:49:24 +0200

ldaptor (0.0.34) unstable; urgency=low

  * Brown paper bag time, 0.0.33 was never uploaded. Epydoc --check only
    check and generates no output, reverting back to do not complain about
    missing docstrings.

 -- Tommi Virtanen <tv@debian.org>  Sun, 23 Jan 2005 03:32:46 +0200

ldaptor (0.0.33) unstable; urgency=low

  * Conceptual changes:
    - Add our own LDAP schema file. To use in slapd, add line "include
      /etc/ldaptor/ldaptor.schema" to /etc/ldap/slapd.conf.
    - Switch service-specific password support in svcbindproxy and webui
      change_password to use new-style password entries, for nicer slapd
      ACLs. Closes: ldaptor#20.

  * API changes:
    - Add a pumpingDeferredError to test utils, for consistency.
    - Allow overriding things by subclassing LDAPConfig and setting
      attributes.
    - Allow overriding identity search filter at LDAPConfig instantiation
      time.
    - Change e.bind() semantics to defer more, and return self or raise.
    - Add LDAPEntryWithClient.bind() that sends a BindRequest to the
      server.
    - Deprecate LDAPClient.bind(dn, auth) in favor of e.bind(auth).
    - Proxy now takes an ILDAPConfig parameter to init and not just
      overrides.

  * Bugfixes:
    - Escape "=" in RDN values.
    - Remove ldaptor.protocols.ldap.__all__, it's unnecessary and had
      wrong content.

  * Cleanups:
    - Convert U32 to unix-style newlines.
    - Epydoc formatting fixes.
    - Make epydoc complain about missing docstrings.
    - Fix API doc home page URL.

  * Packaging:
    - When running unit tests from debian/rules, ensure PYTHONPATH gets an
      explicit . in it -- for the poor guy running a build as root.
      Closes: #291615.
    - Include everything needed for successful unit test run in
      Build-Depends-Indep. Closes: #290236, #291618.

 -- Tommi Virtanen <tv@debian.org>  Sun, 23 Jan 2005 02:52:56 +0200

ldaptor (0.0.32) unstable; urgency=low

  * Conceptual changes:
    - Client-side STARTTLS support. Closes: ldaptor#1.

  * Applications changes:
    - The following now use the configuration, making --base optional:
      - ldaptor-ldap2maradns
      - ldaptor-search
      - ldaptor-ldap2pdns
      - ldaptor-ldap2passwd
      - ldaptor-ldap2dhcpconf
    - ldaptor-ldap2pdns now reconnects when needed.
    - WebUI:
    - Server:

  * API changes:
    - Remove ldapclient.LDAPSearch in favor of e.search().
    - Switch from LDAPClient.queue() to one of the following. Needed to
      notify in flight operations of lost connection, and all around
      prettier.
      - d=c.send(op)
      - d=c.send_multiResponse(op, fn, ..)
      - c.send_noResponse(op)
    - Add LDAPEntryWithClient.lookup() that was accidentally left out.
    - Add BaseLDAPEntry.hasMember().

  * Refactorings to adapt to Ldaptor APIs:
    - Refactor to avoid LDAPSearch, use ldapsyntax, config and
      ldapconnector:
      - ldaptor-ldap2maradns
      - ldaptor-search
      - ldaptor-ldap2pdns
      - ldaptor-ldap2dhcpconf
      - ldaptor-ldap2passwd
      - ldaptor-rename

  * Bugfixes:
    - In ldaptor-ldap2maradns, make sure the netmask.* A record is in
      octet format (and not as number of bits).


=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-distutils.mk
include /usr/share/cdbs/1/rules/simple-patchsys.mk

DEB_COMPRESS_EXCLUDE := .py .js
DEB_DH_INSTALL_SOURCEDIR := debian/python2.4-ldaptor
DEB_DH_ALWAYS_EXCLUDE := .svn

$(patsubst %,binary-post-install/%,$(DEB_PYTHON_REAL_LIB_PACKAGES)):: binary-post-install/python%-ldaptor:
	PYTHONPATH='debian/$(cdbs_curpkg)/usr/lib/python$(patsubst python%-ldaptor,%,$(cdbs_curpkg))/site-packages' \
		'trial$(patsubst python%-ldaptor,%,$(cdbs_curpkg))' --text --tbformat=emacs -R ldaptor

build/ldaptor-doc::
	make -C doc

binary-post-install/ldaptor-utils::
	rm -rf debian/ldaptor-utils/usr/bin/ldaptor-webui

binary-post-install/python2.4-ldaptor:: binary-install/ldaptor-utils binary-install/ldaptor-webui binary-install/ldaptor-common
	rm -rf \
		debian/python2.4-ldaptor/usr/bin \
		debian/python2.4-ldaptor/usr/lib/python2.4/site-packages/ldaptor/apps/webui \
		debian/python2.4-ldaptor/usr/share/locale

binary-post-install/ldaptor-common::
	find debian/ldaptor-common/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

binary-post-install/ldaptor-webui::
	find debian/ldaptor-webui/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor-webui.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

clean::
	find . -type f -name '*.pyc' -print0 \
	| xargs -0 --no-run-if-empty rm --
	make -C doc clean
	rm -rf _trial_temp

## ldaptor 0.0.39

=== doc/Makefile ===
DIAS:= \
	chat-bind.dia \
	chat-search.dia \
	chat-search-pipeline.dia \
	chat-unbind.dia \
	ldapfilter-as-tree.dia \
	ldap-is-a-tree.dia \
	overview.dia

DIAPNG:=$(DIAS:%.dia=%.dia.png)

DOCBOOK:=ldap-intro.xml
SLIDES:=addressbook-slides.xml

GENERATED:=\
	$(DOCBOOK:%.xml=%/index.html) \
	$(SLIDES:%.xml=%/index.html) \
	$(DIAPNG) \
	api

XMLIFY:=sed 's/&/\&amp;/g; s/</\&lt;/g; s/>/\&gt;/g'

all:: $(GENERATED)

clean:
	rm -rf \
		$(GENERATED) \
		ldap-intro \
		$(DIAPNG:%=%.tmp) \
		addressbook-ldif \
		addressbook-session \
		addressbook-slides

rsync: $(GENERATED)
	rsync -a $(DOCBOOK:%.xml=%.html) $(SLIDES:%.xml=%) $(DIAPNG) pyramid.twistedmatrix.com:public_html/ldap-intro/
	rsync -a --exclude '*.pyc' --exclude SCCS --exclude '*~' examples/addressbook/{[0-9]*,README.txt,server}  pyramid.twistedmatrix.com:public_html/ldap-intro/addressbook/

$(DOCBOOK:%.xml=%/index.html): %/index.html: %.xml
	install -d -m0755 '$(@D)'
	xsltproc  --nonet \
		/usr/share/sgml/docbook/stylesheet/xsl/nwalsh/xhtml/docbook.xsl \
		$< \
		>$@.tmp
	mv $@.tmp $@

ldap-intro/index.html: \
	ldap-intro/ldap-is-a-tree.dia.png \
	ldap-intro/ldapfilter-as-tree.dia.png \
	ldap-intro/chat-bind.dia.png \
	ldap-intro/chat-search.dia.png \
	ldap-intro/chat-search-pipeline.dia.png \
	ldap-intro/chat-unbind.dia.png

ldap-intro/%.dia.png: %.dia.png
	install -d -m0755 '$(@D)'
	install -m0644 $< $@.tmp
	mv $@.tmp $@

addressbook-ldif/%.xml: examples/addressbook/server/%.ldif
	install -d -m0755 '$(@D)'
	$(XMLIFY) <$< >$@.tmp
	mv $@.tmp $@

addressbook-session/session-%.xml: examples/addressbook/01_repl/session-%
	install -d -m0755 '$(@D)'
	$(XMLIFY) <$< >$@.tmp
	mv $@.tmp $@

addressbook-slides/%/addressbook-py.html: \
	examples/addressbook/%/addressbook.py tags.j2h
	install -d -m0755 '$(@D)'
	( echo '<font size="+1">' && source-highlight --out-format=xhtml --src-lang=python && echo '</font>' ) <$< >$@.tmp
	mv $@.tmp $@

addressbook-slides/%/addressbook-tac.html: \
	examples/addressbook/%/addressbook.tac tags.j2h
	install -d -m0755 '$(@D)'
	( echo '<font size="+1">' && source-highlight --out-format=xhtml --src-lang=python && echo '</font>' ) <$< >$@.tmp
	mv $@.tmp $@

addressbook-slides/%/searchform-xhtml.html: \
	examples/addressbook/%/searchform.xhtml
	install -d -m0755 '$(@D)'
	( echo '<pre>' && sed 's/&/\&amp;/g; s/</\&lt;/g; s/>/\&gt;/g;' && echo '</pre>' ) <$< >$@.tmp
	mv $@.tmp $@

addressbook-slides/index.html: \
	ldapentry-vs-oo.xml search-inputs.xml

ldap-intro.html: \
	ldapentry-vs-oo.xml search-inputs.xml

$(SLIDES:%.xml=%/index.html): %/index.html: %.xml \
	slides-driver.xsl \
	Makefile $(DIAPNG) \
	addressbook-ldif/doe.xml \
	addressbook-ldif/smith.xml \
	addressbook-session/session-01.xml \
	addressbook-session/session-02.xml \
	addressbook-session/session-03.xml \
	addressbook-session/session-04.xml \
	addressbook-session/session-05.xml \
	addressbook-session/session-06.xml \
	addressbook-session/session-07.xml \
	addressbook-session/session-08.xml \
	addressbook-session/session-09.xml \
	slide-style.css \
	addressbook-slides/02_script/addressbook-py.html \
	addressbook-slides/07_easy/addressbook-py.html \
	addressbook-slides/07_easy/searchform-xhtml.html \
	addressbook-slides/07_easy/addressbook-tac.html
	install -d -m0755 '$(@D)'
	cp -ar /usr/share/sgml/docbook/custom/slides/3.2.0/graphics '$(@D)'
	cp -ar /usr/share/sgml/docbook/custom/slides/3.2.0/browser '$(@D)'
	patch '$(@D)/browser/overlay.js' <overlay.js.patch
	cp $(DIAPNG) '$(@D)'
	cp slide-style.css '$(@D)'
	# TODO --nonet
	cd '$(@D)' && xsltproc \
		--stringparam keyboard.nav 1 \
		--stringparam overlay 1 \
		--stringparam output.indent yes \
		--stringparam graphics.dir graphics \
		--stringparam script.dir browser \
		../slides-driver.xsl \
		'$(addprefix ../,$<)'
	perl -pi -e '\
		s{<a href="(.*?)" target="_top">Click me!</a>}{<iframe width=900 height=600 src="$$1" />}g; \
		' \
		'$(@D)'/foil*.html

%.dia.png: %.dia
	dia --export-to-format=png-libart --export=$@.tmp $<
	mv $@.tmp $@

api:
	epydoc \
	        -o api \
		-n Ldaptor \
		-u http://www.inoi.fi/open/trac/ldaptor/ \
		$$(find ../ldaptor \( -name SCCS -prune \) -o -name '*.py' -print)

.PHONY: api

=== debian/changelog ===
ldaptor (0.0.39) unstable; urgency=low

  * Cleanups:
    - Sort results before comparison in unit tests. Avoid spurious errors
      in test_ldiftree.Tree.test_children_twoChildren. Make unit tests
      explicitly shuffle results to avoid such false negative tests in the
      future. Closes: #307101.

 -- Tommi Virtanen <tv@debian.org>  Fri,  6 May 2005 14:46:31 +0300

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: admin
 Priority: optional
 Maintainer: Tommi Virtanen <tv@debian.org>
-Standards-Version: 3.5.6
-Build-Depends-Indep: python2.2-dev, python2.3-dev, debhelper (>= 4.1.68), docbook-slides (>= 3.2.0), xsltproc, source-highlight, python2.3-epydoc, dia (>= 0.93-2)
+Standards-Version: 3.6.1
+Build-Depends-Indep: python, python2.3-dev, cdbs, debhelper (>= 4.1.68), docbook-slides (>= 3.2.0), xsltproc, source-highlight, python2.3-epydoc, dia (>= 0.93-2), python2.3-twisted (>= 1.3.0), python2.3-nevow (>= 0.3.0), python2.3-pyparsing, python2.3-pyopenssl, python2.3-crypto
 
 Package: ldaptor-utils
 Section: admin
 Architecture: all
-Depends: python (>= 2.3), python (<< 2.4), python2.3-ldaptor
+Depends: ${python:Depends}, python-ldaptor
 Description: Command-line LDAP utilities
  A set of LDAP utilities for use from the command line, including:
  .
@@ -47,7 +47,7 @@
 Package: ldaptor-webui
 Section: admin
 Architecture: all
-Depends: python (>= 2.3), python (<< 2.4), python2.3-ldaptor
+Depends: ${python:Depends}, python2.3-nevow (>= 0.3.0), python2.3-ldaptor
 Description: Web user interface for editing LDAP directories
  A web-based user interface to search and edit information in an LDAP
  directory.
@@ -55,7 +55,7 @@
 Package: python-ldaptor
 Section: python
 Architecture: all
-Depends: python-twisted (>= 1.1.1), python-pyparsing, pwgen, python (>= 2.3), python (<< 2.4), python2.3-ldaptor
+Depends: ${python:Depends}, python-twisted (>= 1.3.0), python-pyparsing
 Description: Pure-Python library for LDAP
  Ldaptor is a pure-Python library that implements
  .
@@ -73,30 +73,10 @@
  This is a dummy package that depends on the correct version of
  python-ldaptor for the default version of Python.
 
-Package: python2.2-ldaptor
-Section: python
-Architecture: all
-Depends: python2.2-twisted (>= 1.1.1), python2.2-pyparsing, pwgen, python2.2
-Description: Pure-Python library for LDAP
- Ldaptor is a pure-Python library that implements
- .
- - LDAP client logic.
- .
- - separately-accessible LDAP and BER protocol message
- generation/parsing.
- .
- - ASCII-format LDAP filter generation and parsing.
- .
- - LDIF format data generation.
- .
- - Samba password changing logic.
- .
- This version is usable with python2.2
-
 Package: python2.3-ldaptor
 Section: python
 Architecture: all
-Depends: python2.3-twisted (>= 1.1.1), python2.3-pyparsing, pwgen, python2.3
+Depends: ${python:Depends}, ldaptor-common, python2.3-twisted (>= 1.3.0), python2.3-pyparsing, pwgen, python2.3-pyopenssl, python2.3-crypto
 Description: Pure-Python library for LDAP
  Ldaptor is a pure-Python library that implements
  .
@@ -125,3 +105,22 @@
  .
  - Slides for a talk "Creating a simple LDAP application"
 
+Package: ldaptor-common
+Section: python
+Architecture: all
+Description: Pure-Python library for LDAP (common files)
+ Ldaptor is a pure-Python library that implements
+ .
+ - LDAP client logic.
+ .
+ - separately-accessible LDAP and BER protocol message
+ generation/parsing.
+ .
+ - ASCII-format LDAP filter generation and parsing.
+ .
+ - LDIF format data generation.
+ .
+ - Samba password changing logic.
+ .
+ This package contains the common files shared between different
+ builds of the library for different Python versions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-distutils.mk

DEB_COMPRESS_EXCLUDE := .py .js
DEB_DH_INSTALL_SOURCEDIR := debian/python2.3-ldaptor
DEB_DH_ALWAYS_EXCLUDE := .svn

# see http://bugs.debian.org/295906
cdbs_python_ver = $(filter-out -%,$(subst -, -,$(patsubst python%,%,$(cdbs_curpkg))))

$(patsubst %,binary-post-install/%,$(DEB_PYTHON_REAL_LIB_PACKAGES)):: binary-post-install/python%-ldaptor:
	PYTHONPATH='debian/$(cdbs_curpkg)/usr/lib/python$(cdbs_python_ver)/site-packages' \
		'trial$(cdbs_python_ver)' --text --tbformat=emacs -R ldaptor

build/ldaptor-doc::
	make -C doc

binary-post-install/ldaptor-utils::
	rm -rf debian/ldaptor-utils/usr/bin/ldaptor-webui

binary-post-install/python2.3-ldaptor:: binary-install/ldaptor-utils binary-install/ldaptor-webui binary-install/ldaptor-common
	rm -rf \
		debian/python2.3-ldaptor/usr/bin \
		debian/python2.3-ldaptor/usr/lib/python2.3/site-packages/ldaptor/apps/webui \
		debian/python2.3-ldaptor/usr/share/locale

binary-post-install/ldaptor-common::
	find debian/ldaptor-common/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

binary-post-install/ldaptor-webui::
	find debian/ldaptor-webui/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor-webui.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

clean::
	find . -type f -name '*.pyc' -print0 \
	| xargs -0 --no-run-if-empty rm --
	make -C doc clean
	rm -rf _trial_temp

## ldaptor 0.0.41ubuntu1

=== debian/changelog ===
ldaptor (0.0.41ubuntu1) breezy; urgency=low

  * Resynchronise with Debian.
  * Removed the final test suite, cause it throws errors. Testing needed

 -- Stephan Hermann <sh@sourcecode.de>  Mon, 25 Jul 2005 17:46:09 +0200

ldaptor (0.0.41) unstable; urgency=low

  * Bugfixes:
    - Handle attributeTypes written with non-canonical cases better in
      webui edit and add. Stops tracebacks complaining about unknown
      attribute types, especially related to x500uniqueidentifier.
      Closes: ldaptor#25.

 -- Tommi Virtanen <tv@debian.org>  Thu, 26 May 2005 21:07:24 +0300

ldaptor (0.0.40) unstable; urgency=low

  * Bugfixes:
    - Make e.setPassword() set Samba passwords even when Samba
      objectClasses are spelled with non-canonical case.
      Closes: ldaptor#31.

 -- Tommi Virtanen <tv@debian.org>  Thu, 26 May 2005 19:47:53 +0300

ldaptor (0.0.39ubuntu1) breezy; urgency=low

  * Resynchronise with Debian.

 -- Andrew Mitchell <ajmitch@gnu.org>  Wed, 11 May 2005 19:03:02 +1200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Tommi Virtanen <tv@debian.org>
 Standards-Version: 3.6.1
-Build-Depends-Indep: python, python2.3-dev, cdbs, debhelper (>= 4.1.68), docbook-slides (>= 3.2.0), xsltproc, source-highlight, python2.3-epydoc, dia (>= 0.93-2), python2.3-twisted (>= 1.3.0), python2.3-nevow (>= 0.3.0), python2.3-pyparsing, python2.3-pyopenssl, python2.3-crypto
+Build-Depends-Indep: python, python-dev (>= 2.4), cdbs (>= 0.4.25-1ubuntu1), debhelper (>= 4.2.28), docbook-slides (>= 3.2.0), xsltproc, source-highlight, python2.4-epydoc, dia (>= 0.93-2), python2.4-twisted (>= 1.3.0), python2.4-nevow (>= 0.3.0), python2.4-pyparsing, python2.4-pyopenssl, python2.4-crypto
 
 Package: ldaptor-utils
 Section: admin
@@ -47,7 +47,7 @@
 Package: ldaptor-webui
 Section: admin
 Architecture: all
-Depends: ${python:Depends}, python2.3-nevow (>= 0.3.0), python2.3-ldaptor
+Depends: ${python:Depends}, python2.4-nevow (>= 0.3.0), python2.4-ldaptor
 Description: Web user interface for editing LDAP directories
  A web-based user interface to search and edit information in an LDAP
  directory.
@@ -73,10 +73,10 @@
  This is a dummy package that depends on the correct version of
  python-ldaptor for the default version of Python.
 
-Package: python2.3-ldaptor
+Package: python2.4-ldaptor
 Section: python
 Architecture: all
-Depends: ${python:Depends}, ldaptor-common, python2.3-twisted (>= 1.3.0), python2.3-pyparsing, pwgen, python2.3-pyopenssl, python2.3-crypto
+Depends: ${python:Depends}, ldaptor-common, python2.4-twisted (>= 1.3.0), python2.4-pyparsing, pwgen, python2.4-pyopenssl, python2.4-crypto
 Description: Pure-Python library for LDAP
  Ldaptor is a pure-Python library that implements
  .
@@ -91,7 +91,7 @@
  .
  - Samba password changing logic.
  .
- This version is usable with python2.3
+ This version is usable with python2.4
 
 Package: ldaptor-doc
 Section: doc

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-distutils.mk
include /usr/share/cdbs/1/rules/simple-patchsys.mk

DEB_COMPRESS_EXCLUDE := .py .js
DEB_DH_INSTALL_SOURCEDIR := debian/python2.4-ldaptor
DEB_DH_ALWAYS_EXCLUDE := .svn

# see http://bugs.debian.org/295906
cdbs_python_ver = $(filter-out -%,$(subst -, -,$(patsubst python%,%,$(cdbs_curpkg))))

#$(patsubst %,binary-post-install/%,$(DEB_PYTHON_REAL_LIB_PACKAGES)):: binary-post-install/python%-ldaptor:
#	PYTHONPATH='debian/$(cdbs_curpkg)/usr/lib/python$(cdbs_python_ver)/site-packages' \
#		'trial$(cdbs_python_ver)' --text --tbformat=emacs -R ldaptor

build/ldaptor-doc::
	make -C doc

binary-post-install/ldaptor-utils::
	rm -rf debian/ldaptor-utils/usr/bin/ldaptor-webui

binary-post-install/python2.4-ldaptor:: binary-install/ldaptor-utils binary-install/ldaptor-webui binary-install/ldaptor-common
	rm -rf \
		debian/python2.4-ldaptor/usr/bin \
		debian/python2.4-ldaptor/usr/lib/python2.4/site-packages/ldaptor/apps/webui \
		debian/python2.4-ldaptor/usr/share/locale

binary-post-install/ldaptor-common::
	find debian/ldaptor-common/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

binary-post-install/ldaptor-webui::
	find debian/ldaptor-webui/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor-webui.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

clean::
	find . -type f -name '*.pyc' -print0 \
	| xargs -0 --no-run-if-empty rm --
	make -C doc clean
	rm -rf _trial_temp

## ldaptor 0.0.42ubuntu3

=== doc/Makefile ===
--- 
+++ 
@@ -124,10 +124,7 @@
 		--stringparam script.dir browser \
 		../slides-driver.xsl \
 		'$(addprefix ../,$<)'
-	perl -pi -e '\
-		s{<a href="(.*?)" target="_top">Click me!</a>}{<iframe width=900 height=600 src="$$1" />}g; \
-		' \
-		'$(@D)'/foil*.html
+	perl -pi -e 's{<a href="(.*?)" target="_top">Click me!</a>}{<iframe width=900 height=600 src="$$1" />}g;' $(@D)/foil*.html
 
 %.dia.png: %.dia
 	dia --export-to-format=png-libart --export=$@.tmp $<

=== debian/changelog ===
ldaptor (0.0.42ubuntu3) dapper; urgency=low

  * Sigh. It seems l10n-update wants net access. Don't call it instead.

 -- Steve Kowalik <stevenk@ubuntu.com>  Wed,  3 May 2006 22:21:20 +1000

ldaptor (0.0.42ubuntu2) dapper; urgency=low

  * Run admin/l10n-update on build, and remove empty POT files. This stops
    pkgstriptranslations breaking.

 -- Steve Kowalik <stevenk@ubuntu.com>  Wed,  3 May 2006 17:53:25 +1000

ldaptor (0.0.42ubuntu1) dapper; urgency=low

  * Rip out the built-against-python2.3 version.
  * Correct multiple FTBFSes.

 -- Steve Kowalik <stevenk@ubuntu.com>  Sun, 30 Apr 2006 21:51:29 +1000

ldaptor (0.0.42) unstable; urgency=low

  * Applications changes:
    - In webui, don't change config base DN based on the DN in the URL.
      Instead, remember new ICurrentDN in context for that purpose. Allows
      guessing right next free uid numbers even when looking at a subtree
      that doesn't include (all of) the user accounts.
    - Add ldaptor-ldap2dnszones, generates bind-style DNS zones from
      LDAP ipHosts and ipNetworks.
    - Add french translation, update l10n. Closes: #301547.

  * Refactorings to adapt to Nevow APIs:
    - Kludge webui add to work with Choice in both nevow 0.3 and newer.

  * Bugfixes:
    - Apparently locateConfigurable can not return a Deferred. Handle it.
    - Make startTLS no longer hang. Thanks to Christopher Zorn
      <christopher.zorn@gmail.com>.
    - Fix and unit test ReadOnlyInMemoryLDAPEntry.search()
    - Add a dummy fetch() to ReadOnlyInMemoryLDAPEntry for API consistency.

  * Cleanups:
    - Port changes and minor bugfixes from nevow.i18n:
      + r2303: Get rid of nevow.i18n.FlatteningProxy, it isn't needed
        anymore and caused trouble with unicode etc.
      + r2290: i18n bugfix: make _("%(foo)d") % {"foo": 42} work.
      + r2251: add ungettext (pluralization) support for nevow.i18n.
      + r2250: nevow.i18n string formatting fails with %d and %f
      + r2241: guard against nonexisting localizations.
      + r2240: also look for locales without a dash-suffix.

  * Packaging:
    - doko, I find your lack of trust in API stability disturbing.  Yes,
      things work even if you upgrade. Closes: #327032.
    - Build-depend on python-epydoc not python2.3-epydoc. Closes: #320897.
    - Remove old unused packaging helpers.
    - Add package python2.4-ldaptor.

  * Administrivia:
    - No longer using bk, fix test coverage reporting.

 -- Tommi Virtanen <tv@debian.org>  Mon, 24 Oct 2005 18:19:46 +0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Tommi Virtanen <tv@debian.org>
 Standards-Version: 3.6.1
-Build-Depends-Indep: python, python-dev (>= 2.4), cdbs (>= 0.4.25-1ubuntu1), debhelper (>= 4.2.28), docbook-slides (>= 3.2.0), xsltproc, source-highlight, python2.4-epydoc, dia (>= 0.93-2), python2.4-twisted (>= 1.3.0), python2.4-nevow (>= 0.3.0), python2.4-pyparsing, python2.4-pyopenssl, python2.4-crypto
+Build-Depends-Indep: python, python2.4-dev, cdbs, debhelper (>= 4.1.68), docbook-slides (>= 3.2.0), xsltproc, source-highlight, python-epydoc, dia (>= 0.93-2), python2.4-twisted (>= 1.3.0), python2.4-nevow (>= 0.3.0), python2.4-pyparsing, python2.4-pyopenssl, python2.4-crypto
 
 Package: ldaptor-utils
 Section: admin
@@ -31,6 +31,9 @@
  .
  ldaptor-ldap2dhcpconf -- Create dhcp.conf based on LDAP host info.
  .
+ ldaptor-ldap2dnszones -- Create a DNS zone files based on LDAP host
+ info.
+ .
  ldaptor-ldap2maradns -- Create a maradns zone file based on LDAP host
  info.
  .
@@ -47,7 +50,7 @@
 Package: ldaptor-webui
 Section: admin
 Architecture: all
-Depends: ${python:Depends}, python2.4-nevow (>= 0.3.0), python2.4-ldaptor
+Depends: ${python:Depends}, python-nevow (>= 0.3.0), python-ldaptor
 Description: Web user interface for editing LDAP directories
  A web-based user interface to search and edit information in an LDAP
  directory.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-distutils.mk

DEB_COMPRESS_EXCLUDE := .py .js
DEB_DH_INSTALL_SOURCEDIR := debian/python2.4-ldaptor
DEB_DH_ALWAYS_EXCLUDE := .svn

# see http://bugs.debian.org/295906
cdbs_python_ver = $(filter-out -%,$(subst -, -,$(patsubst python%,%,$(cdbs_curpkg))))

$(patsubst %,binary-post-install/%,$(DEB_PYTHON_REAL_LIB_PACKAGES)):: binary-post-install/python%-ldaptor:
	PYTHONPATH='debian/$(cdbs_curpkg)/usr/lib/python$(cdbs_python_ver)/site-packages' \
		'trial$(cdbs_python_ver)' --tbformat=emacs ldaptor

build/ldaptor-utils::
	for pot in po/*.pot ; do test -s $$pot || rm -fv $$pot ; done

build/ldaptor-doc::
	make -C doc

binary-post-install/ldaptor-utils::
	rm -rf debian/ldaptor-utils/usr/bin/ldaptor-webui

binary-post-install/python%-ldaptor:: binary-install/ldaptor-utils binary-install/ldaptor-webui binary-install/ldaptor-common
	rm -rf \
		debian/python$*-ldaptor/usr/bin \
		debian/python$*-ldaptor/usr/lib/python$*/site-packages/ldaptor/apps/webui \
		debian/python$*-ldaptor/usr/lib/python$*/site-packages/ldaptor/test/test_webui.py \
		debian/python$*-ldaptor/usr/share/locale

binary-post-install/ldaptor-common::
	find debian/ldaptor-common/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

binary-post-install/ldaptor-webui::
	find debian/ldaptor-webui/usr/share/locale \
		-name '*.mo' \
		-a \! -name 'ldaptor-webui.mo' \
		-print0 \
	| xargs -0 --no-run-if-empty rm --

clean::
	find . -type f -name '*.pyc' -print0 \
	| xargs -0 --no-run-if-empty rm --
	make -C doc clean
	rm -rf _trial_temp

## ldaptor 0.0.43

=== doc/Makefile ===
--- 
+++ 
@@ -124,7 +124,9 @@
 		--stringparam script.dir browser \
 		../slides-driver.xsl \
 		'$(addprefix ../,$<)'
-	perl -pi -e 's{<a href="(.*?)" target="_top">Click me!</a>}{<iframe width=900 height=600 src="$$1" />}g;' $(@D)/foil*.html
+	perl -pi -e \
+		's{<a href="(.*?)" target="_top">Click me!</a>}{<iframe width=900 height=600 src="$$1" />}g;' \
+		'$(@D)'/foil*.html
 
 %.dia.png: %.dia
 	dia --export-to-format=png-libart --export=$@.tmp $<
